//
//  ConnectionsIdentifier.h
//  SolarSeek
//
//  Created by Erick Fejta on 05/02/17.
//  Copyright 2005 Erick Fejta. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class UnidentifiedConnection;
@class NetSocket;

@interface ConnectionsIdentifier : NSObject {
	UnidentifiedConnection *_connectionOpened;

	NSMutableSet		*_connectionsOpening;
	NetSocket			*_socketListening;
}

- (id)init;

- (UnidentifiedConnection *)connectionOpened;
- (BOOL)listening;
- (UInt16)portListening;

- (BOOL)startListening;
- (BOOL)startListeningOnPorts:(NSRange)ports;
- (void)stopListening;

- (BOOL)shouldRequestIncomingConnectionSecond;
- (BOOL)shouldRequestIncomingConnectionFirst;
@end
