//
//  FSourceListView.h
//  SolarSeek
//
//  Created by Erick Fejta on 05/03/22.
//  Copyright 2005 Erick Fejta. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FOutlineViewDataSource.h"
#import "FOutlineView.h"

@class FSourceListView;

@protocol FSourceListElement <FOutlineViewElement>
- (NSView *)view;
@end


@interface FSourceListElement : FOutlineViewElement <FSourceListElement>
{
	NSView *_view;
}

- (id)initWithView:(NSView *)view;

- (NSView *)view;
- (void)setView:(NSView *)view;
@end

@interface FSourceListArrayElement : FOutlineViewArrayElement <FSourceListElement>
{
	NSView *_view;
}

- (id)initWithView:(NSView *)view;

- (NSView *)view;
- (void)setView:(NSView *)view;
@end

@interface FSourceListElement (Removal)
- (void)removeFromSourceList;
@end

@interface FSourceListArrayElement (Removal)
- (void)removeFromSourceList;
@end





@interface FSourceListView : FOutlineView {
	IBOutlet NSView *_contentView;
}

- (id)initWithFrame:(NSRect)frameRect contentView:(NSView *)contentView;

- (NSView *)contentView;
- (void)setContentView:(NSView *)view;

@end
