/* SearchView */

#import <Cocoa/Cocoa.h>

#import "SolarSeekApplication.h"

@class BrowseElement;

@interface SearchesView : NSView
{
	SourceListArrayElement *_elementsSearch;
	NSMutableDictionary *_dictionaryElementsSearch;
	NSMutableDictionary *_dictionaryElementsBrowse;
	
	IBOutlet NSPopUpButton *menuSearchType;
	IBOutlet NSArrayController *nibControllerParticipants;
    IBOutlet NSObjectController *nibSearches;
    IBOutlet NSTableView *tableSearches;
	IBOutlet NSTextField *textBrowseUser;
    IBOutlet NSSearchField *textSearch;
	IBOutlet NSTextField *textSpecificUser;
    IBOutlet NSPopUpButton *typeSearch;
	
	IBOutlet NSView *nibBrowseView;
	IBOutlet NSBrowser *nibBrowser;
	IBOutlet NSTableView *nibTableBrowseResults;
}

- (id<SourceListElement>)element;

- (IBAction)clear:(id)sender;
- (IBAction)loadSearch:(id)sender;
- (IBAction)makeKey:(id)sender;
- (IBAction)moreSearch:(id)sender;
- (IBAction)removeSearch:(id)sender;
- (IBAction)saveSearch:(id)sender;
- (IBAction)select:(id)sender;
- (IBAction)selectTextSearch:(id)sender;
- (IBAction)selectAndSearchChats:(id)sender;
- (IBAction)selectAndSearchSelectedPeer:(id)sender;
- (IBAction)startNetworkSearch:(id)sender;
- (IBAction)startSearch:(id)sender;
- (IBAction)viewResults:(id)sender;

- (void)endBrowseElement:(BrowseElement *)be;
@end
