//
//  ServerConnectionController.h
//  SolarSeek
//
//  Created by Erick Fejta on 05/02/06.
//  Copyright 2005 Erick Fejta. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class SolarSeekEngine;
@class ServerConnection;
@class Message;
@class TimelyInformation;

#import "EnumTypes.h"

@interface ServerConnectionController : NSObject {
	SolarSeekEngine *_engine;
	ServerConnection *_serverConnection;
	BOOL _loggedIn;
	Availability _availability;
	TimelyInformation *_privileged;
	NSString *_greeting;
	NSString *_error;
	NSString *_admin;
	NSTimeInterval secondsDelayPing;
	NSTimer *_pingTimer;
	
	NSString *_usernameLoggedIn;
	SEL	_selectorRetrieverPassword;
	id	_objectRetrieverPassword;
}

- (id)initWithEngine:(SolarSeekEngine *)engine;

//@private

//@public 
- (Availability)availability;
- (BOOL)loggedIn;
- (NSString *)messageGreeting;
- (NSString *)messageError;
- (NSString *)messageAdministrative;
- (BOOL)privileged;
- (NSDate *)privilegedDateExpired;
- (NSString *)username;

- (void)setAvailability:(Availability)status;


@end
