//
//  SourceListElement.h
//  SolarSeek
//
//  Created by Erick Fejta on 05/03/15.
//  Copyright 2005 Erick Fejta. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FSourceListView.h"

//- (NSView *)view;
//- (NSArray *)children;			//access to the children.
//- (BOOL)expandable;				//can we expand this item?
//- (id<FOutlineViewElement>)item;	//default item to display.
//- (OutlineViewElementDefaultState)stateDefault;	//default state when added the first time.

@protocol SourceListElement <FSourceListElement>

- (NSImage *)icon;
- (NSString *)name;
- (NSAttributedString *)nameAttributed;
- (NSString *)titleWindow;
- (NSAttributedString *)text;
- (NSArray *)buttons;

- (NSArray *)conversations;
- (NSArray *)participants;
- (NSArray *)shares;
- (NSArray *)searches;

- (void)refresh;
- (void)refreshAndRequestAttention:(BOOL)ask;

- (BOOL)isRequestingAttention;

- (void)setSelected:(BOOL)selected;
- (BOOL)isSelected;

+ (float)defaultSize;
+ (NSParagraphStyle *)defaultStyle;
@end

@interface SourceListElement : FSourceListElement <SourceListElement> {
	BOOL _bold;
	BOOL _selected;
}

//- (id)initWithView:(NSView *)view;

@end

@interface SourceListArrayElement : FSourceListArrayElement <SourceListElement> {
	BOOL _bold;
	BOOL _selected;
}

@end