//
//  TimelyInformation.h
//  SolarSeek
//
//  Created by Erick Fejta on 05/02/04.
//  Copyright 2005 Erick Fejta. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface TimelyInformation : NSObject {
	id info;	//retained while valid
	NSDate *_dateValidated;
	NSTimeInterval _durationValid;
	BOOL popped;
}

- (id)initWithInfo:(id)i validForSeconds:(NSTimeInterval)s;
+ (id)timelyInformation:(id)i validForSeconds:(NSTimeInterval)s;

- (id)info;
- (NSTimeInterval)durationValid;
- (NSDate *)dateValidated;
- (void)refresh;
- (BOOL)isValid;
- (void)invalidate;
- (NSTimeInterval)secondsRemaining;
- (NSDate *)dateExpired;
- (void)setDateExpired:(NSDate *)d;
@end
